using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public struct msf
    {
        public int minutes;
        public int seconds;
        public int frames;
    }

    class CCDAudio
    {
        [DllImport("winmm.dll")]
            extern static int mciSendString(string command,            
             StringBuilder Buffer, int bufferLength, int nothing);
        
        private int err;
        private StringBuilder response = new StringBuilder(128);


        public CCDAudio()
        {
            err = mciSendString("open cdaudio", response, 128, 0);
            Console.WriteLine("{0} error(s)", err);
        }
        ~CCDAudio()
        {
            err = mciSendString("close all", response, 128, 0);
        }

        public int play()
        {
           return err = mciSendString("play cdaudio", response, 128, 0);
           
        }
        public int stop()
        {
            return err = mciSendString("stop cdaudio", response, 128, 0);

        }
        public int pause()
        {
            return err = mciSendString("pause cdaudio", response, 128, 0);

        }
        public int eject()
        {
            return err = mciSendString("set cdaudio door open", response, 128, 0);

        }
        public int seek(int track)
        {
            err = mciSendString("set cdaudio time format tmsf", response, 128, 0);
            if (err != 0) { return err; };
            err = mciSendString("seek cdaudio to " + track.ToString() , response, 128, 0);
            return err;

        }
             

        public string getDiscData()
        {
            StringBuilder command = new StringBuilder(256);
            err = mciSendString("set cdaudio time format msf", response, 128, 0);
            if (err != 0) { return err.ToString(); };
            err = mciSendString("status cdaudio number of tracks", response, 128, 0);
            if (err != 0) { return err.ToString(); };


            int tracks = Convert.ToInt32(response.ToString());
            command.Append(tracks+" ");
          

            int[] offsets = new int[tracks];
            string[] temp;
            int minutes, seconds, frames; 
            
            for (int i = 1; i <= tracks; i++)
            {
                err = mciSendString("status cdaudio position track " + i.ToString(), response, 128, 0);
                temp = (response.ToString()).Split(':');
                minutes = Convert.ToInt32(temp[0]);
                seconds = Convert.ToInt32(temp[1]);
                frames = Convert.ToInt32(temp[2]);
                offsets[i - 1] = minutes * 60 * 75 + seconds * 75 + frames;
                command.Append(offsets[i-1]+" ");
             }

            err = mciSendString("status cdaudio length track " + tracks.ToString(), response, 128, 0);
            
            temp = (response.ToString()).Split(':');
            minutes = Convert.ToInt32(temp[0]);
            seconds = Convert.ToInt32(temp[1]);
            frames = Convert.ToInt32(temp[2]) + 1;

            int playtime;
            playtime=offsets[tracks-1]+minutes * 60*75  + seconds*75+frames;
           
            playtime = playtime / 75;
            command.Append(playtime);
            

            return command.ToString();
        }
    }
}
